//+------------------------------------------------------------------+
//|                                           Pivot_Points_v2017.mq4 |
//|                               Copyright  2017, ViverdeForex.com |
//|       Escrito por ViverdeForex contato: contato@viverdeforex.com |   
//|                                     https://www.viverdeforex.com |                                    
//+------------------------------------------------------------------+
#property copyright "Copyright  2017, ViverdeForex"
#property link      "https://www.viverdeforex.com"

#property indicator_chart_window
#property indicator_buffers   4
#property indicator_color1    LightBlue
#property indicator_color2    Tomato
#property indicator_color3    Aqua
#property indicator_color4    Orange

extern int     CountPeriods=10;
extern string  TimePeriod="D1";
extern bool    Plot_pivots=true;
extern bool    Plot_middle=false;
extern bool    Plot_camarilla=false;

   datetime time1;
   datetime time2;
   double open,close,high,low;
   double P,R1,R2,R3,S1,S2,S3,Middle_S3,Middle_S2,Middle_S1,Middle_R1,Middle_R2,Middle_R3;
   double H1,H2,H3,H4,L1,L2,L3,L4,Range;
   double pstyle, mstyle,cstyle;
   int shift, num, period;
     
   void ObjDel()
   {
      for (;num<=CountPeriods;num++)
      {
      ObjectDelete("D1 PP ["+num+"]");
      ObjectDelete("D1 R1 ["+num+"]");
      ObjectDelete("D1 R2 ["+num+"]");
      ObjectDelete("D1 R3 ["+num+"]");
      ObjectDelete("D1 S1 ["+num+"]");
      ObjectDelete("D1 S2 ["+num+"]");
      ObjectDelete("D1 S3 ["+num+"]");
      
      ObjectDelete("D1 Middle_S3 ["+num+"]");
      ObjectDelete("D1 Middle_S2 ["+num+"]");
      ObjectDelete("D1 Middle_S1 ["+num+"]");
      ObjectDelete("D1 Middle_R1 ["+num+"]");
      ObjectDelete("D1 Middle_R2 ["+num+"]");
      ObjectDelete("D1 Middle_R3 ["+num+"]");
      
      ObjectDelete("D1 H1 ["+num+"]");
      ObjectDelete("D1 H2 ["+num+"]");
      ObjectDelete("D1 H3 ["+num+"]");
      ObjectDelete("D1 H4 ["+num+"]");
      ObjectDelete("D1 L1 ["+num+"]");
      ObjectDelete("D1 L2 ["+num+"]");
      ObjectDelete("D1 L3 ["+num+"]");
      ObjectDelete("D1 L4 ["+num+"]");
      }
   }

   void PlotLine(string name,double value,double line_color,double style)
   {
   ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, 1);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
    }        
int init()
  {
   if (TimePeriod=="H1" || TimePeriod=="60") period=PERIOD_H1; 
   else
   if (TimePeriod=="H4" || TimePeriod=="240") period=PERIOD_H4; 
   else
   if (TimePeriod=="D1" || TimePeriod=="1440") period=PERIOD_D1;
   else
   if (TimePeriod=="W1" || TimePeriod=="10080") period=PERIOD_W1; 
   else
   if (TimePeriod=="MN" || TimePeriod=="43200") period=PERIOD_MN1;
   else
   {
   Comment("Wrong TimePeriod. Must be H1, H4, D1, W1 or MN"); 
   return(0);
   }
  return(0);
  }
   
   
int deinit()
  {
   ObjDel();
   Comment("");
   return(0);
  }

int start()
  {
  int i;
     
  ObjDel();
  num=0;
  
  for (shift=CountPeriods-1;shift>=0;shift--)
  {
  time1=iTime(NULL,period,shift);
             
  high  = iHigh(NULL,period,shift+1);
  low   = iLow(NULL,period,shift+1);
  open  = iOpen(NULL,period,shift+1);
  close = iClose(NULL,period,shift+1);
  
  P  = (high+low+close)/3.0;
        
  R1 = 2*P-low;
  R2 = P+(high - low);
  R3 = (2*P)+(high-(2*low));
        
  S1 = 2*P-high;
  S2 = P-(high - low);
  S3 = (2*P)-((2*high)-low);
         
  Middle_S3=0.5*(S2+S3);
  Middle_S2=0.5*(S1+S2);
  Middle_S1=0.5*(P+S1);
  Middle_R1=0.5*(P+R1);
  Middle_R2=0.5*(R1+R2);
  Middle_R3=0.5*(R2+R3);
         
  Range = high - low;
  H4 = close + (Range * 1.1/2.0);
  H3 = close + (Range * 1.1/4.0);
  H2 = close + (Range * 1.1/6.0);
  H1 = close + (Range * 1.1/12.0);

  L1 = close - (Range * 1.1/12.0);
  L2 = close - (Range * 1.1/6.0);
  L3 = close - (Range * 1.1/4.0);
  L4 = close - (Range * 1.1/2.0);
       
  time2=time1+period*60;
         
  pstyle=0;
  mstyle=3;
  cstyle=1;
  num=shift;
       
  PlotLine("D1 PP ["+num+"]",P,Aqua,pstyle);
  if(Plot_pivots)
  {
        
   PlotLine("D1 R1 ["+num+"]",R1,MediumSeaGreen,pstyle);
   PlotLine("D1 R2 ["+num+"]",R2,MediumSeaGreen,pstyle);
   PlotLine("D1 R3 ["+num+"]",R3,MediumSeaGreen,pstyle);
               
   PlotLine("D1 S1 ["+num+"]",S1,MediumSeaGreen,pstyle);
   PlotLine("D1 S2 ["+num+"]",S2,MediumSeaGreen,pstyle);
   PlotLine("D1 S3 ["+num+"]",S3,MediumSeaGreen,pstyle);
  }
         
  if(Plot_middle)
  {
   PlotLine("D1 Middle_S3 ["+num+"]",Middle_S3,MediumSeaGreen,cstyle);
   PlotLine("D1 Middle_S2 ["+num+"]",Middle_S2,MediumSeaGreen,cstyle);
   PlotLine("D1 Middle_S1 ["+num+"]",Middle_S1,MediumSeaGreen,cstyle);
   PlotLine("D1 Middle_R1 ["+num+"]",Middle_R1,MediumSeaGreen,cstyle);
   PlotLine("D1 Middle_R2 ["+num+"]",Middle_R2,MediumSeaGreen,cstyle);
   PlotLine("D1 Middle_R3 ["+num+"]",Middle_R3,MediumSeaGreen,cstyle);
  }
         
  if(Plot_camarilla)
  {
   PlotLine("D1 H4 ["+num+"]",H4,LightBlue,cstyle);
   PlotLine("D1 H3 ["+num+"]",H3,DeepSkyBlue,cstyle);
   PlotLine("D1 H2 ["+num+"]",H2,MediumSlateBlue,cstyle);
   PlotLine("D1 H1 ["+num+"]",H1,RoyalBlue,cstyle);
      
   PlotLine("D1 L1 ["+num+"]",L1,Chocolate,cstyle);
   PlotLine("D1 L2 ["+num+"]",L2,Orange,cstyle);
   PlotLine("D1 L3 ["+num+"]",L3,Goldenrod,cstyle);
   PlotLine("D1 L4 ["+num+"]",L4,Yellow,cstyle);
  }
  }
   return(0);
  }
//+------------------------------------------------------------------+